program pic2text;
(* World in 3D -- a ray caster engine for Ti-92
 * Copyright (C) 1998-1999 Silicone <Julien.Viard@enst.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *)
uses graph256,lilbm,ddir,crt;

type
abyte=array[0..1]of byte;

var
  n:string;
  k,e:char;
  x,y,xo,yo,p:integer;
  sp,sm:^abyte;
  f:text;

procedure savesp;
var
  i:word;
  v:byte;
begin
  writeln(f);
  for i:=0 to 255 do begin
    v:=sp^[i+4];
    if (i and $f)=0 then begin
      writeln(f);
      write(f,'	dc.b ',v);
    end else write(f,',',v);
  end;

end;


begin
 n:=dirchoix('*.lbm');
 init256;
 getmem(sm,260);
 for x:=0 to 7 do begin
   setpix(x*2,0,255);
   setpix(x*2+1,15,255);
   setpix(0,x*2,255);
   setpix(15,x*2+1,255);
 end;
 getspr(0,0,15,15,sm);
 litlbm(n);
 if errc<>0 then begin
   fin256;
   writeln('Erreur:',errmsg[errc])
 end else begin
   getmem(sp,260);

  assign(f,'pic2text.inc');
  rewrite(f);

   x:=0;y:=0;xo:=x;yo:=y;p:=1;
   getspr(x,y,x+15,y+15,sp);
   aftspr(x,y,0,sm);
   repeat
     k:=readkey;
     case k of
       #0:begin
            e:=readkey;
            case e of
              #75:dec(x,p);
              #77:inc(x,p);
              #72:dec(y,p);
              #80:inc(y,p);
            end;
          end;
       '1':p:=1;
       '2':p:=16;

       's':savesp;
     end;

     if x<0 then x:=0;
     if x>303 then x:=303;
     if y<0 then y:=0;
     if y>184 then y:=184;

     if (xo<>x) or (yo<>y) then begin
       affspr(xo,yo,sp);
       getspr(x,y,x+15,y+15,sp);
       aftspr(x,y,0,sm);
       xo:=x;yo:=y;
     end;
   until k=#27;

  close(f);
   fin256;
 end;

 restorepath;

end.